#
# spec file for package cron (Version 3.0.1)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         cron
Copyright:    public domain
Group:        System Environment/Base
Provides:     cron
Requires:     smtp_daemon
Autoreqprov:  on
Version:      3.0.1
Release:      416
Summary:      cron daemon
Source:       cron-3.0.1.tar.gz
Source1:      cron.init
Source2:      rc.config.cron
Patch:        cron-3.0.1.dif
Patch1:       username_boverflow.dif
Patch2:       setuid.dif

%description
Automatically starts programs at specific times.
Add new entries with "crontab -e".
(See "man 5 crontab" and "man 1 crontab" for documentation.)
Under /etc you can find the directories cron.hourly, cron.daily,
cron.weekly and cron.monthly.  Scripts and programs, that are located
there will be started automatically.

Authors:
--------
    Paul Vixie <paul@vix.com>

SuSE series: a

%prep
%setup
%patch
%patch1
%patch2

%build
make

%install
make install
install -d /var/spool/cron
install -d /var/spool/cron/tabs
install -d /var/spool/cron/lastrun
install -m 600 deny.sample /var/spool/cron/deny
install -m 600 sample.root /etc/crontab
install -d /etc/cron.d
install -d /etc/cron.hourly
install -d /etc/cron.daily
install -d /etc/cron.weekly
install -d /etc/cron.monthly
install -d /usr/lib/cron
install -o root -g root -m744 run-crons /usr/lib/cron
install -d /etc/init.d
cp %{SOURCE1} /etc/init.d/cron
chmod 744 /etc/init.d/cron
ln -sf ../../etc/init.d/cron /usr/sbin/rccron
install -d /var/adm/fillup-templates
cp %{SOURCE2} /var/adm/fillup-templates

%post
echo "Updating etc/rc.config..."
if [ -x bin/fillup ] ; then
  bin/fillup -q etc/rc.config var/adm/fillup-templates/rc.config.cron
else
  echo "ERROR: fillup not found. This should not happen. Please compare"
  echo "etc/rc.config and var/adm/fillup-templates/rc.config.cron"
  echo "and update by hand."
fi
#
# Initialize runlevel links
#
sbin/insserv etc/init.d/cron
#
# Move the old crontabs to the new location
if [ -d var/cron ] ; then
	cp -pr var/cron/* var/spool/cron
	rm -rf var/cron
fi
cp etc/crontab etc/crontab.old
sed "s|/var/cron|/var/spool/cron|g" < etc/crontab.old > etc/crontab
#
grep -v "#" etc/crontab 2> /dev/null | grep /usr/lib/cron/run-crons > /dev/null || {
mkdir -p var/adm/notify/messages
cat << EOT > var/adm/notify/messages/cron
Hallo (english text below),
Unter /etc befinden sich Verzeichnisse namens cron.hourly, cron.daily,
cron.weekly und cron.monthly.  Skripte und Programme die in diesen
Verzeichnissen abgelegt werden, sollen automatisch gestartet werden.  Damit
dies geschieht, tragen Sie bitte folgendes in Ihre /etc/crontab ein:
*/15 * * * *   root  test -x /usr/lib/cron/run-crons && /usr/lib/cron/run-crons
Beachten Sie auch bitte, da das Skript /root/bin/cron.daily in
/etc/cron.daily/aaa_base umbenannt wurde.  Bitte entfernen Sie den Eintrag
auf der /etc/crontab.
Hello.
Under /etc you can find the directories cron.hourly, cron.daily,
cron.weekly and cron.monthly.  Scripts and programs, that are located
there shall be started automatically.  To make this work, please aadd the
following line to your /etc/crontab:
*/15 * * * *   root  test -x /usr/lib/cron/run-crons && /usr/lib/cron/run-crons
Please note, that /root/bin/cron.daily has moved to /etc/cron.daily/aaa_base.
Please remove the entry from your crontab.
Have a lot of fun...
                          Your SuSE Team
EOT
}
grep -v "#" var/spool/cron/tabs/root 2> /dev/null | grep cron.daily > /dev/null || exit 0
mkdir -p var/adm/notify/messages
cat << EOT > var/adm/notify/messages/crontab
(English translation is below.)
Bei Ihnen ist immer noch "cron.daily" in /var/spool/cron/tabs/root. Bitte
starten Sie als root "crontab -e" und loeschen Sie die Zeile, in der
"cron.daily" aufgerufen wird.
Alle Eintragungen in /var/spool/cron/tabs/root sind nun nach /etc/crontab
gewandert. Diese Datei hat ein extra Feld, in dem der Benutzer eingetragen
werden kann, unter dem der cron-Eintrag gestartet wird.
Damit kann man nun alle sysadm-Cronjobs (root,uucp,news) in einer Datei
eintragen und muss auch kein "su" dort eintragen.
Damit cron.daily nicht doppelt gestartet wird, muss man es aus der alten
Datei /var/spool/cron/tabs/root ueber "crontab -e" loeschen.
You still have "cron.daily" in /var/spool/cron/tabs/root. Please execute
"crontab -e" as user root and delete the line which starts "cron.daily".
Instead of distributing default crontab-entries in /var/spool/cron/tabs/root,
we now have a /etc/crontab file. That file has an additional entry which
contains the name of the user the script should be executed as.
So you can have all sysadm scripts (root,news,uucp) in on file, /etc/crontab.
EOT

%postun
sbin/insserv etc/init.d

%files
%dir /var/spool/cron
%dir /var/spool/cron/tabs
%dir /var/spool/cron/lastrun
%doc CHANGES CONVERSION FEATURES MAIL MANIFEST README THANKS
%config /etc/init.d/cron
%config(noreplace) /etc/crontab
%config(noreplace) /var/spool/cron/deny
%doc %{_mandir}/man1/crontab.1.gz
%doc %{_mandir}/man5/crontab.5.gz
%doc %{_mandir}/man8/cron.8.gz
/usr/bin/crontab
/usr/sbin/cron
/usr/sbin/rccron
/usr/lib/cron
%dir /etc/cron.d
%dir /etc/cron.hourly
%dir /etc/cron.daily
%dir /etc/cron.weekly
%dir /etc/cron.monthly
/var/adm/fillup-templates/rc.config.cron

%changelog -n cron
* Fri Sep 28 2001 - ro@suse.de
- removed duplicate trap in run-crons (#11472)
* Thu Sep 13 2001 - ro@suse.de
- updated run-crons (feedback from volker_apelt, thanks)
* Fri Sep 07 2001 - schwab@suse.de
- Instead of closing std{in,out,err} redirect them to /dev/null.
* Wed Aug 15 2001 - fehr@suse.de
- add log messages when one of the /etc/cron/cron.* scripts fails
  (thanks for suggestion by Steffen Dettmer)
* Mon May 07 2001 - draht@suse.de
- Added security patch for a wrong setuid() call.
* Tue Apr 24 2001 - ro@suse.de
- added rc-link
* Mon Apr 23 2001 - ro@suse.de
- added updated startscript and rc.config variable
* Thu Apr 12 2001 - werner@suse.de
- Close stdin, stdout, and stderr on forking of the daemon.
* Wed Feb 14 2001 - fehr@suse.de
- add patch to prevent buffer overflow with usernames longer than
  19 characters
* Tue Feb 06 2001 - fehr@suse.de
- Make it compile with new glibc
- remove calls to fax utilities and texpire from default crontab
* Tue Dec 12 2000 - werner@suse.de
- Add cron.hourly because we provide /etc/cron.hourly/
- Remove lock files not at same time but with a quater offset
- Don't run *.rpmorig, *.rpmnew, *.rmpsave, *.swap, *.bak, *~, #*
- Don run a script if it is already running
- Remove `echo' to enable DTS patch of Thomas
* Fri Dec 08 2000 - fehr@suse.de
- fix bug introduced in last change
* Mon Nov 20 2000 - fehr@suse.de
- add security patch from Daniel Jacobowitz to cron
- prevent cron.daily called twice when changing from DST to normal (#998)
* Wed Nov 15 2000 - fehr@suse.de
- add most of the patches of Chris D. Faulhaber (jedgar@fxp.org) (#4249)
* Tue Sep 05 2000 - fehr@suse.de
- make sematic of cron.monthly clearer. It is now executed on the
  first check in run-crons executed in a month but at most once
  per month. Older semantic was to execute every 30 days which
  resulted in being called twice per month when month has 31 days
  and first execution was on 1st day of month. (#3850)
* Fri Jul 21 2000 - fehr@suse.de
- fix the use of ifdef __linux__ (everywhere else __linux is used)
* Wed May 31 2000 - fehr@suse.de
- Start script with "nice -15"
* Mon May 22 2000 - kukuk@suse.de
- Fix post install section
* Tue May 16 2000 - kukuk@suse.de
- Move /var/cron -> /var/spool/cron (FHS 2.1)
* Sun Feb 27 2000 - kukuk@suse.de
- Move /usr/man -> /usr/share/man
* Mon Jan 24 2000 - uli@suse.de
- added -D__linux to cope with gcc 2.95
* Thu Dec 02 1999 - bs@suse.de
- removed CDR_PROG section from run-crons. this leads to problems in
  some network environments.
* Mon Sep 20 1999 - ro@suse.de
- added Requires smtp_daemon
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Aug 30 1999 - kukuk@suse.de
- always use fork instead of vfork
* Fri Aug 27 1999 - fehr@suse.de
- prevent sendmail from being called as root
* Thu Aug 26 1999 - fehr@suse.de
- fixed some possible buffer overflow exploits
* Fri Jul 23 1999 - bs@suse.de
- redirect stderr of apm call to /dev/null
* Thu Jul 15 1999 - bs@suse.de
- don't run cron jobs via run-cron if
  o  a cd writer is running
  o  laptop is AC-offline
- /etc/crontab:
  o  don't log every start of run-crons
  o  run faxclean only once a day
* Mon Mar 29 1999 - ro@suse.de
- added cron.d feature from debian-cron
* Mon Feb 01 1999 - bs@suse.de
- merged beta and stable version
- added entries in crontab to delete lastrun files, to let cronjobs be started
  at night.
* Fri Jan 08 1999 - bs@suse.de
- changed run-crons to work around finds 'strange behavior'
* Fri Dec 18 1998 - ro@suse.de
- use SIGCHLD instead of SIGCLD
* Tue Dec 15 1998 - bs@suse.de
- fixed xargs in run-crons
* Mon Dec 14 1998 - bs@suse.de
- fixed bug in run-crons
* Mon Dec 14 1998 - bs@suse.de
- added /etc/cron.* feature.
* Tue Nov 17 1998 - bs@suse.de
- added texpire to crontab.
- use noreplace for config files.
* Thu Sep 10 1998 - bs@suse.de
- fixed problem with non existing var/cron/tabs/root.
* Mon Sep 07 1998 - bs@suse.de
- fixed check for /var/cron/tabs/root in %%post section
* Mon Jul 07 1997 - florian@suse.de
- warn if cron.daily is still in /var/cron/tabs/root
- start cron.daily 10 minutes earlier, so that duplicate
  entries don't overlap :-(
* Thu Jun 05 1997 - florian@suse.de
- use /etc/crontab instead of /var/cron/tabs/root
* Fri May 16 1997 - bs@suse.de
- removed *.new -> orig stuff behavior, since is not neded for rpm.
* Wed Apr 30 1997 - florian@suse.de
- fix screen output ifrom ALLOW_FILE to DENY_FILE
- do not include syslog.c anymore, libc is fixed
- disable debugging compile time switch
- add some security patches
* Thu Feb 27 1997 - bs@suse.de
  added crontab entries for hylafax.
* Wed Jan 22 1997 - florian@suse.de
- syslogging works even if syslogd is restarted
* Thu Jan 02 1997 - bs@suse.de
- beautified man page
- store crontab.root.new in /root instead of /tmp
* Thu Jan 02 1997 - bs@suse.de
  atrun aus crontab fr root rausgenommen.
